clear all
clc

disp('Converter Topology')
c=input('Choose convert topology(1=buck,2=boost): ');

if c==1
disp('You chose to design a buck converter')
Vmax=input('Maximum input voltage[V]: ');
Vmin=input('Minmum input voltage[V]: ');
Vo=input('Desired output voltage[V]: ');
Pmax=input('Maximum power output[W]: ');
Pmin=input('Minimum power output[W]: ');
fs=input('Desired switching frequency [kHz]: ');
fs=fs*1e3;

%Inductor calculations
ts=1/fs;
D=Vo/Vmax;
toff=(1-D)*ts;
Et=Vo*toff;
r=0.4;
LxIL=Et/r;
Io=Pmax/Vo;

L=LxIL/Io;
Irated=(1+r/2)*Io;

%Capacitor calulations
disp('The voltage ripple alowed is below 1% of the output voltage')
C=ts^2*(1-D)/(8*L*0.01);

% Controller calculations
R1=input('What is the feedback resistor value?[ohm]');
fcross=fs/3;
R=(Vo^2)/Pmax;
K=1;
G0=K*R;
%A=((1/R)+(1-0.5-D)/(L*fs))^-1;
%B=2;


fp=(2*pi*R*C)^-1;
fp0=fcross/G0;

L
C
R1
C2=(2*pi*R1*fp0)^-1
R2=(2*pi*C2*fp)^-1
C1=(5e-3*C/R2)

elseif c==2
disp('You chose to design a boost converter')
Vdmax=input('Maximum input voltage[V]: ');
Vdmin=input('Minmum input voltage[V]: ');
Vo=input('Desired output voltage[V]: ');
Pmax=input('Maximum power output[W]: ');
Pmin=input('Minimum power output[W]: ');
fs=input('Desired switching frequency [kHz]: ');
fs=fs*1e3;

cm=input('1=CCM, 2=DCM:')

%Inductor design
if cm==1
%CCM
D=(Vo-Vdmin)/Vo;
ts=1/fs;
ton=D*ts;
Et=ton*Vdmin;
LIL=Et/0.4;
IL=(Pmax/Vo)/(1-D);
L=(LIL/IL)/1e-6
Irated=1.2*IL

%Capacitor design
C=((D*ts)/(0.01*Vo^2/Pmax))/1e-6

%Controller design
m=1;
Rmap=2;
R=Vo^2/Pmax;
D=(Vo-Vdmin)/Vo;
R1=11e3
fesr=(2*pi*5e-3*C*1e-6)^-1

A=((2/R)+((1-0.5)*(1-D)^3)/(L*fs))^-1;
B=Rmap/(1-D);
Go=A/B;
fp=(2*pi*A*C*1e-6)^-1;

fcross=fs/24;
fp0=fcross/Go;
C2=(2*pi*R1*fp0)^-1
R2=(2*pi*C2*fp)^-1
C1=(2*pi*R2*fesr)^-1

elseif cm==2
% DCM
%Inductor design
ts=1/fs;
D=(Vo-Vdmin)/Vo;
Iomax=Pmax/Vo;
L=(ts*Vo*D*(1-D)^2)/(2*Iomax)
L=input('Set desired Inductance[H]: ')
%Capacitor design
C=((D*ts)/(0.01*Vo^2/Pmax))/1e-6

%Controller design
m=1;
Rmap=1.5;
R=Vo^2/Pmax;
D=(Vo-Vdmin)/Vo;
R1=11e3
fesr=(2*pi*5e-3*C*1e-6)^-1

A=((2/R)+((1-0.5)*(1-D)^3)/(L*fs))^-1;
B=Rmap/(1-D);
Go=A/B;
fp=(2*pi*A*C*1e-6)^-1;

fcross=fs/6;
fp0=fcross/Go;
C2=(2*pi*R1*fp0)^-1
R2=(2*pi*C2*fp)^-1
C1=(2*pi*R2*fesr)^-1

end




end